<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1" /><title>ChunkedOutputStream xref</title>
<link type="text/css" rel="stylesheet" href="../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../apidocs/org/apache/commons/httpclient/ChunkedOutputStream.html">View Javadoc</a></div><pre>

<a name="1" href="#1">1</a>   <em class="comment">/*</em>
<a name="2" href="#2">2</a>   <em class="comment"> * $HeadURL: https://svn.apache.org/repos/asf/httpcomponents/oac.hc3x/trunk/src/java/org/apache/commons/httpclient/ChunkedOutputStream.java $</em>
<a name="3" href="#3">3</a>   <em class="comment"> * $Revision$</em>
<a name="4" href="#4">4</a>   <em class="comment"> * $Date$</em>
<a name="5" href="#5">5</a>   <em class="comment"> *</em>
<a name="6" href="#6">6</a>   <em class="comment"> * ====================================================================</em>
<a name="7" href="#7">7</a>   <em class="comment"> *</em>
<a name="8" href="#8">8</a>   <em class="comment"> *  Licensed to the Apache Software Foundation (ASF) under one or more</em>
<a name="9" href="#9">9</a>   <em class="comment"> *  contributor license agreements.  See the NOTICE file distributed with</em>
<a name="10" href="#10">10</a>  <em class="comment"> *  this work for additional information regarding copyright ownership.</em>
<a name="11" href="#11">11</a>  <em class="comment"> *  The ASF licenses this file to You under the Apache License, Version 2.0</em>
<a name="12" href="#12">12</a>  <em class="comment"> *  (the "License"); you may not use this file except in compliance with</em>
<a name="13" href="#13">13</a>  <em class="comment"> *  the License.  You may obtain a copy of the License at</em>
<a name="14" href="#14">14</a>  <em class="comment"> *</em>
<a name="15" href="#15">15</a>  <em class="comment"> *      <a href="http://www.apache.org/licenses/LICENSE-2.0" target="alexandria_uri">http://www.apache.org/licenses/LICENSE-2.0</a></em>
<a name="16" href="#16">16</a>  <em class="comment"> *</em>
<a name="17" href="#17">17</a>  <em class="comment"> *  Unless required by applicable law or agreed to in writing, software</em>
<a name="18" href="#18">18</a>  <em class="comment"> *  distributed under the License is distributed on an "AS IS" BASIS,</em>
<a name="19" href="#19">19</a>  <em class="comment"> *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.</em>
<a name="20" href="#20">20</a>  <em class="comment"> *  See the License for the specific language governing permissions and</em>
<a name="21" href="#21">21</a>  <em class="comment"> *  limitations under the License.</em>
<a name="22" href="#22">22</a>  <em class="comment"> * ====================================================================</em>
<a name="23" href="#23">23</a>  <em class="comment"> *</em>
<a name="24" href="#24">24</a>  <em class="comment"> * This software consists of voluntary contributions made by many</em>
<a name="25" href="#25">25</a>  <em class="comment"> * individuals on behalf of the Apache Software Foundation.  For more</em>
<a name="26" href="#26">26</a>  <em class="comment"> * information on the Apache Software Foundation, please see</em>
<a name="27" href="#27">27</a>  <em class="comment"> * &lt;<a href="http://www.apache.org/" target="alexandria_uri">http://www.apache.org/</a>>.</em>
<a name="28" href="#28">28</a>  <em class="comment"> *</em>
<a name="29" href="#29">29</a>  <em class="comment"> */</em>
<a name="30" href="#30">30</a>  
<a name="31" href="#31">31</a>  <strong>package</strong> <a href="../../../../org/apache/commons/httpclient/package-summary.html">org.apache.commons.httpclient</a>;
<a name="32" href="#32">32</a>  
<a name="33" href="#33">33</a>  <strong>import</strong> java.io.IOException;
<a name="34" href="#34">34</a>  <strong>import</strong> java.io.OutputStream;
<a name="35" href="#35">35</a>  
<a name="36" href="#36">36</a>  <strong>import</strong> org.apache.commons.httpclient.util.EncodingUtil;
<a name="37" href="#37">37</a>  
<a name="38" href="#38">38</a>  <em>/**<em>*</em></em>
<a name="39" href="#39">39</a>  <em> * Implements HTTP chunking support. Writes are buffered to an internal buffer (2048 default size).</em>
<a name="40" href="#40">40</a>  <em> * Chunks are guaranteed to be at least as large as the buffer size (except for the last chunk).</em>
<a name="41" href="#41">41</a>  <em> *</em>
<a name="42" href="#42">42</a>  <em> * @author Mohammad Rezaei, Goldman, Sachs &amp; Co.</em>
<a name="43" href="#43">43</a>  <em> */</em>
<a name="44" href="#44">44</a>  <strong>public</strong> <strong>class</strong> <a href="../../../../org/apache/commons/httpclient/ChunkedOutputStream.html">ChunkedOutputStream</a> <strong>extends</strong> OutputStream {
<a name="45" href="#45">45</a>  
<a name="46" href="#46">46</a>      <em class="comment">// ------------------------------------------------------- Static Variables</em>
<a name="47" href="#47">47</a>      <strong>private</strong> <strong>static</strong> <strong>final</strong> byte CRLF[] = <strong>new</strong> byte[] {(byte) 13, (byte) 10};
<a name="48" href="#48">48</a>  
<a name="49" href="#49">49</a>      <em>/**<em>* End chunk */</em></em>
<a name="50" href="#50">50</a>      <strong>private</strong> <strong>static</strong> <strong>final</strong> byte ENDCHUNK[] = CRLF;
<a name="51" href="#51">51</a>  
<a name="52" href="#52">52</a>      <em>/**<em>* 0 */</em></em>
<a name="53" href="#53">53</a>      <strong>private</strong> <strong>static</strong> <strong>final</strong> byte ZERO[] = <strong>new</strong> byte[] {(byte) '0'};
<a name="54" href="#54">54</a>  
<a name="55" href="#55">55</a>      <em class="comment">// ----------------------------------------------------- Instance Variables</em>
<a name="56" href="#56">56</a>      <strong>private</strong> OutputStream stream = <strong>null</strong>;
<a name="57" href="#57">57</a>  
<a name="58" href="#58">58</a>      <strong>private</strong> byte[] cache;
<a name="59" href="#59">59</a>  
<a name="60" href="#60">60</a>      <strong>private</strong> <strong>int</strong> cachePosition = 0;
<a name="61" href="#61">61</a>  
<a name="62" href="#62">62</a>      <strong>private</strong> <strong>boolean</strong> wroteLastChunk = false;
<a name="63" href="#63">63</a>  
<a name="64" href="#64">64</a>      <em class="comment">// ----------------------------------------------------------- Constructors</em>
<a name="65" href="#65">65</a>      <em>/**<em>*</em></em>
<a name="66" href="#66">66</a>  <em>     * Wraps a stream and chunks the output.</em>
<a name="67" href="#67">67</a>  <em>     * @param stream to wrap</em>
<a name="68" href="#68">68</a>  <em>     * @param bufferSize minimum chunk size (excluding last chunk)</em>
<a name="69" href="#69">69</a>  <em>     * @throws IOException</em>
<a name="70" href="#70">70</a>  <em>     * </em>
<a name="71" href="#71">71</a>  <em>     * @since 3.0</em>
<a name="72" href="#72">72</a>  <em>     */</em>
<a name="73" href="#73">73</a>      <strong>public</strong> <a href="../../../../org/apache/commons/httpclient/ChunkedOutputStream.html">ChunkedOutputStream</a>(OutputStream stream, <strong>int</strong> bufferSize) throws IOException {
<a name="74" href="#74">74</a>          <strong>this</strong>.cache = <strong>new</strong> byte[bufferSize];
<a name="75" href="#75">75</a>          <strong>this</strong>.stream = stream;
<a name="76" href="#76">76</a>      }
<a name="77" href="#77">77</a>  
<a name="78" href="#78">78</a>      <em>/**<em>*</em></em>
<a name="79" href="#79">79</a>  <em>     * Wraps a stream and chunks the output. The default buffer size of 2048 was chosen because</em>
<a name="80" href="#80">80</a>  <em>     * the chunk overhead is less than 0.5%</em>
<a name="81" href="#81">81</a>  <em>     * @param stream</em>
<a name="82" href="#82">82</a>  <em>     * @throws IOException</em>
<a name="83" href="#83">83</a>  <em>     */</em>
<a name="84" href="#84">84</a>      <strong>public</strong> <a href="../../../../org/apache/commons/httpclient/ChunkedOutputStream.html">ChunkedOutputStream</a>(OutputStream stream) throws IOException {
<a name="85" href="#85">85</a>          <strong>this</strong>(stream, 2048);
<a name="86" href="#86">86</a>      }
<a name="87" href="#87">87</a>  
<a name="88" href="#88">88</a>      <em class="comment">// ----------------------------------------------------------- Internal methods</em>
<a name="89" href="#89">89</a>      <em>/**<em>*</em></em>
<a name="90" href="#90">90</a>  <em>     * Writes the cache out onto the underlying stream</em>
<a name="91" href="#91">91</a>  <em>     * @throws IOException</em>
<a name="92" href="#92">92</a>  <em>     * </em>
<a name="93" href="#93">93</a>  <em>     * @since 3.0</em>
<a name="94" href="#94">94</a>  <em>     */</em>
<a name="95" href="#95">95</a>      <strong>protected</strong> <strong>void</strong> flushCache() throws IOException {
<a name="96" href="#96">96</a>          <strong>if</strong> (cachePosition > 0) {
<a name="97" href="#97">97</a>              byte chunkHeader[] = EncodingUtil.getAsciiBytes(
<a name="98" href="#98">98</a>                      Integer.toHexString(cachePosition) + <span class="string">"\r\n"</span>);
<a name="99" href="#99">99</a>              stream.write(chunkHeader, 0, chunkHeader.length);
<a name="100" href="#100">100</a>             stream.write(cache, 0, cachePosition);
<a name="101" href="#101">101</a>             stream.write(ENDCHUNK, 0, ENDCHUNK.length);
<a name="102" href="#102">102</a>             cachePosition = 0;
<a name="103" href="#103">103</a>         }
<a name="104" href="#104">104</a>     }
<a name="105" href="#105">105</a> 
<a name="106" href="#106">106</a>     <em>/**<em>*</em></em>
<a name="107" href="#107">107</a> <em>     * Writes the cache and bufferToAppend to the underlying stream</em>
<a name="108" href="#108">108</a> <em>     * as one large chunk</em>
<a name="109" href="#109">109</a> <em>     * @param bufferToAppend</em>
<a name="110" href="#110">110</a> <em>     * @param off</em>
<a name="111" href="#111">111</a> <em>     * @param len</em>
<a name="112" href="#112">112</a> <em>     * @throws IOException</em>
<a name="113" href="#113">113</a> <em>     * </em>
<a name="114" href="#114">114</a> <em>     * @since 3.0</em>
<a name="115" href="#115">115</a> <em>     */</em>
<a name="116" href="#116">116</a>     <strong>protected</strong> <strong>void</strong> flushCacheWithAppend(byte bufferToAppend[], <strong>int</strong> off, <strong>int</strong> len) throws IOException {
<a name="117" href="#117">117</a>         byte chunkHeader[] = EncodingUtil.getAsciiBytes(
<a name="118" href="#118">118</a>                 Integer.toHexString(cachePosition + len) + <span class="string">"\r\n"</span>);
<a name="119" href="#119">119</a>         stream.write(chunkHeader, 0, chunkHeader.length);
<a name="120" href="#120">120</a>         stream.write(cache, 0, cachePosition);
<a name="121" href="#121">121</a>         stream.write(bufferToAppend, off, len);
<a name="122" href="#122">122</a>         stream.write(ENDCHUNK, 0, ENDCHUNK.length);
<a name="123" href="#123">123</a>         cachePosition = 0;
<a name="124" href="#124">124</a>     }
<a name="125" href="#125">125</a> 
<a name="126" href="#126">126</a>     <strong>protected</strong> <strong>void</strong> writeClosingChunk() throws IOException {
<a name="127" href="#127">127</a>         <em class="comment">// Write the final chunk.</em>
<a name="128" href="#128">128</a> 
<a name="129" href="#129">129</a>         stream.write(ZERO, 0, ZERO.length);
<a name="130" href="#130">130</a>         stream.write(CRLF, 0, CRLF.length);
<a name="131" href="#131">131</a>         stream.write(ENDCHUNK, 0, ENDCHUNK.length);
<a name="132" href="#132">132</a>     }
<a name="133" href="#133">133</a> 
<a name="134" href="#134">134</a>     <em class="comment">// ----------------------------------------------------------- Public Methods</em>
<a name="135" href="#135">135</a>     <em>/**<em>*</em></em>
<a name="136" href="#136">136</a> <em>     * Must be called to ensure the internal cache is flushed and the closing chunk is written.</em>
<a name="137" href="#137">137</a> <em>     * @throws IOException</em>
<a name="138" href="#138">138</a> <em>     * </em>
<a name="139" href="#139">139</a> <em>     * @since 3.0</em>
<a name="140" href="#140">140</a> <em>     */</em>
<a name="141" href="#141">141</a>     <strong>public</strong> <strong>void</strong> finish() throws IOException {
<a name="142" href="#142">142</a>         <strong>if</strong> (!wroteLastChunk) {
<a name="143" href="#143">143</a>             flushCache();
<a name="144" href="#144">144</a>             writeClosingChunk();
<a name="145" href="#145">145</a>             wroteLastChunk = <strong>true</strong>;
<a name="146" href="#146">146</a>         }
<a name="147" href="#147">147</a>     }
<a name="148" href="#148">148</a> 
<a name="149" href="#149">149</a>     <em class="comment">// -------------------------------------------- OutputStream Methods</em>
<a name="150" href="#150">150</a>     <em>/**<em>*</em></em>
<a name="151" href="#151">151</a> <em>     * Write the specified byte to our output stream.</em>
<a name="152" href="#152">152</a> <em>     * </em>
<a name="153" href="#153">153</a> <em>     * Note: Avoid this method as it will cause an inefficient single byte chunk. </em>
<a name="154" href="#154">154</a> <em>     * Use write (byte[], int, int) instead.</em>
<a name="155" href="#155">155</a> <em>     * </em>
<a name="156" href="#156">156</a> <em>     * @param b The byte to be written</em>
<a name="157" href="#157">157</a> <em>     * @throws IOException if an input/output error occurs</em>
<a name="158" href="#158">158</a> <em>     */</em>
<a name="159" href="#159">159</a>     <strong>public</strong> <strong>void</strong> write(<strong>int</strong> b) throws IOException {
<a name="160" href="#160">160</a>         cache[cachePosition] = (byte) b;
<a name="161" href="#161">161</a>         cachePosition++;
<a name="162" href="#162">162</a>         <strong>if</strong> (cachePosition == cache.length) flushCache();
<a name="163" href="#163">163</a>     }
<a name="164" href="#164">164</a> 
<a name="165" href="#165">165</a>     <em>/**<em>*</em></em>
<a name="166" href="#166">166</a> <em>     * Writes the array. If the array does not fit within the buffer, it is</em>
<a name="167" href="#167">167</a> <em>     * not split, but rather written out as one large chunk.</em>
<a name="168" href="#168">168</a> <em>     * @param b</em>
<a name="169" href="#169">169</a> <em>     * @throws IOException</em>
<a name="170" href="#170">170</a> <em>     * </em>
<a name="171" href="#171">171</a> <em>     * @since 3.0</em>
<a name="172" href="#172">172</a> <em>     */</em>
<a name="173" href="#173">173</a>     <strong>public</strong> <strong>void</strong> write(byte b[]) throws IOException {
<a name="174" href="#174">174</a>         <strong>this</strong>.write(b, 0, b.length);
<a name="175" href="#175">175</a>     }
<a name="176" href="#176">176</a> 
<a name="177" href="#177">177</a>     <strong>public</strong> <strong>void</strong> write(byte src[], <strong>int</strong> off, <strong>int</strong> len) throws IOException {
<a name="178" href="#178">178</a>         <strong>if</strong> (len >= cache.length - cachePosition) {
<a name="179" href="#179">179</a>             flushCacheWithAppend(src, off, len);
<a name="180" href="#180">180</a>         } <strong>else</strong> {
<a name="181" href="#181">181</a>             System.arraycopy(src, off, cache, cachePosition, len);
<a name="182" href="#182">182</a>             cachePosition += len;
<a name="183" href="#183">183</a>         }
<a name="184" href="#184">184</a>     }
<a name="185" href="#185">185</a> 
<a name="186" href="#186">186</a>     <em>/**<em>*</em></em>
<a name="187" href="#187">187</a> <em>     * Flushes the underlying stream, but leaves the internal buffer alone.</em>
<a name="188" href="#188">188</a> <em>     * @throws IOException</em>
<a name="189" href="#189">189</a> <em>     */</em>
<a name="190" href="#190">190</a>     <strong>public</strong> <strong>void</strong> flush() throws IOException {
<a name="191" href="#191">191</a>         stream.flush();
<a name="192" href="#192">192</a>     }
<a name="193" href="#193">193</a> 
<a name="194" href="#194">194</a>     <em>/**<em>*</em></em>
<a name="195" href="#195">195</a> <em>     * Finishes writing to the underlying stream, but does NOT close the underlying stream.</em>
<a name="196" href="#196">196</a> <em>     * @throws IOException</em>
<a name="197" href="#197">197</a> <em>     */</em>
<a name="198" href="#198">198</a>     <strong>public</strong> <strong>void</strong> close() throws IOException {
<a name="199" href="#199">199</a>         finish();
<a name="200" href="#200">200</a>         <strong>super</strong>.close();
<a name="201" href="#201">201</a>     }
<a name="202" href="#202">202</a> }
</pre>
<hr/><div id="footer">This page was automatically generated by <a href="http://maven.apache.org/">Maven</a></div></body>
</html>

